' ------------ fr AtTiny45 -------------
'Fuse settings fr den verwendeten ATTiny 45
$prog &HFF , &HE2 , &HDD , &HFF                             ' generated. Take care that the chip supports all fuse bytes.
'----------------------------------------
$regfile = "attiny45.dat"
$crystal = 8000000

$hwstack = 32                                               ' default use 16 for the hardware stack
$swstack = 16                                               ' default use 16 for the SW stack
$framesize = 40                                             ' default use 16 for the frame space

' Alias defines
Ir_out Alias Portb.3                                        ' IR-Signal Output
Ppm_in Alias Pinb.2                                         ' PPM Input

Testpin Alias Portb.4

'Dimensionierung von Variablen
Dim B As Byte
Dim Sende As Bit

'---------- Initialisierung aller notwendigen Controlregister-Bits
Disable Interrupts

Config Ir_out = Output
Config Ppm_in = Input

Config Testpin = Output

Mcucr.pud = 1                                               ' interne PullUps prinzipiell enablen
Ppm_in = 1                                                  ' internen PullUp an Pin PB1 (=Pin 6) einschalten

'---------- Timer initialisieren
Config Timer0 = Timer , Prescale = 256                      ' 8bit Timer -> max 256

'Timer0 = 162                                                ' Timer0 preset fr 3 ms
'Timer0 = 130                                                ' Timer0 preset fr 4 ms
'Timer0 = 115                                                ' Timer0 preset fr 4,5 ms
'Timer0 = 99                                                 ' Timer0 preset fr 5 ms
'Timer0 = 37                                                 ' Timer0 preset fr 7 ms
Const Timervalue = 37
Timer0 = Timervalue

On Timer0 Detectrxpause                                     'timer overflow = pause in receiver's signal

'---------- Interrupts initialisieren
Config Int0 = Rising
On Int0 Generateburst                                       ' bei PinChangeIRQ auf Pin ? - Flanke PPM
Enable Int0

'---------- Ende Initialisierung aller notwendigen Controlregister-Bits

Enable Interrupts
Enable Timer0

' ------------- Hauptschleife Start ------------
Sende = 1                                                   ' fr den ersten Durchgang setzen
Testpin = 0

Do
                                                         ' vorwiegend Nichts tun
Loop
' ------------- Hauptschleife Ende -------------

' -------------- Subroutines --------------

' ----On INT0----------------------------------------------------------
Generateburst:
   Disable Int0                                             ' weitere Interrupts verhindern  (passiert automatisch)
   Timer0 = Timervalue                                      ' Timer0 wieder aufziehen, weil keine lange Pause erkannt wurde

   ' nur jeden zweiten Impulszug des Senders bertragen,
   '  sonst floatet der IR-Empfnger weg und die bertragung reit ab
   If Sende = 1 Then
      'Der TSOP-IR-Empfnger macht aus diesem Impulszug ein Signal in der passenden Lnge.
      'Bei den Waitus-Aufrufen sind _Konstanten_ zu verwenden!
      'Nimmt man Variablen, haut das Timing vorne und hinten nicht hin, alles viel zu langsam

      Set Ir_out                                            ' 1. Impuls ohne Verzgerung einschalten
      Waitus 8                                              ' und die erste Highphase anschlieen

      For B = 0 To 10                                       ' dann 11 weitere Impulse
         Reset Ir_out
         Waitus 17                                          ' Tastverhltnis etwa 1/3 - 2/3
         Set Ir_out                                         ' die Waitus-Pausen mssen jeweils um 1 niedriger sein
         Waitus 7                                           ' wegen der Programmlogic, die Zeit braucht
      Next B
      Reset Ir_out                                          ' zum Schluss wieder OFF

   End If

   Enable Int0                                              ' IRQ wieder frei geben
Return

' -----On Timer0-------------------------------------------------------
Detectrxpause:
   If Sende = 0 Then                                        ' Alternativ "Toggle Sende" verwenden
      Sende = 1
   Else
      Sende = 0
   End If
Return

End
'----Programmende------------------------------------------------------